#include "stdafx.h";
#include<iostream>
using namespace std;

struct recUtente{
  char nominativo[32]; // cognome e nome
  char telefono[16];   // telefono
};

void scambio(recUtente &x, recUtente &y){
  recUtente z;
  z=x;
  x=y;
  y=z;
}

int comparaStringhe(char s1[],char s2[]){
	int i=0;
	while ((s1[i]!='\0') && (s2[i]!='\0')){
		if (s1[i]<s2[i]) 
			return -1;
		else if (s1[i]>s2[i])
			   return 1;
		i++;
	}
	if ((s1[i]=='\0') && (s2[i]=='\0')) return 0;
    if (s1[i]!='\0') return -1;
	return 1;
}

void exchangeSort (recUtente vet[], int N){
 int i,j;
 for (i=0; i< N-1; i++) // ciclo esterno per elementi fissi
  for (j=i+1; j<N; j++) // ciclo interno per elementi successivi
  //confronto con elementi successivi in funzione del tempo
   if (comparaStringhe(vet[i].nominativo, vet[j].nominativo)==1)
    scambio(vet[i], vet[j]); // eventuale scambio elementi
}

int ricercaBinaria(recUtente vet[], int N, char K[], int &passi){
 int inizio=0, fine, centro;
 fine = N-1;
 while (inizio <= fine){
  passi++;
  centro = (inizio + fine )/2; // elemento centrale
  if (comparaStringhe(vet[centro].nominativo, K)==0)
   return centro; // valore K trovato in posizione centro
  if (comparaStringhe(vet[centro].nominativo, K)==-1)
   inizio = centro + 1;
  else
   fine = centro - 1;
 }
 // se l'esecuzione arriva a questo punto significa che il valore K
 // NON  presente nel vettore:
 return -1;
}



void main(void){
 int i,n_utenti,passi_ricerca=0,esito_ricerca;
 recUtente tabella[100];
 char nome[32];

 cout<<"Inserire numero utenti tabella (max 100): ";
 cin>>n_utenti;
 cout<<endl;
 
 for (i=0; i<n_utenti; i++){
    cout<<"--- Utente "<<(i+1)<<endl;
    cin.ignore(); //per sincronizzare la successiva cin.getline con le altre cin
    cout<<"nominativo.....: ";
    cin.getline(tabella[i].nominativo,32);
    cout<<"telefono.......: ";
    cin.getline(tabella[i].telefono,16);

 }
 exchangeSort (tabella, n_utenti);
 cout<<endl<<"------ Tabella ordinata ------"<<endl;
 for (i=0; i<n_utenti; i++)
	cout<<"Utente: "<<tabella[i].nominativo<<" telefono "<< tabella[i].telefono<<endl;

 cout<<endl<<"Nominativo da ricercare: ";
 cin.getline(nome,32);

 esito_ricerca=ricercaBinaria(tabella, n_utenti, nome, passi_ricerca);
 if (esito_ricerca==-1)
  cout <<"Nominativo non trovato";
 else 
  cout <<"Nominativo trovato in posizione "<<esito_ricerca;
 cout<< " (la ricerca ha impiegato "<<passi_ricerca<<" passi)"<<endl;
}

